package Logoved::DB::Rule::Matcher::Pattern;
use Moo;
extends 'Logoved::DB::Rule::Matcher';
has 'patterns' => (is => 'ro');

sub match {
    my ($self, $line, $chomped_line)=@_;
    my @match;
    foreach my $pattern (@{$self->{patterns}}) {
	my @match=($chomped_line =~ $pattern);
	if (@match>0) {
	    my $source=$self->source;
	    #warn 'Logoved: ', $source->name, ' ',$source->file, ': ', $line;
	    my @args=(
		rule => $self->rule,
		logfile => $source->file,
		lineno => $source->lineno,
		line => $line,
		);
	    # regex has $#+ groups, see @+, @LAST_MATCH_END
	    # http://perldoc.perl.org/perlvar.html#@LAST_MATCH_END
	    push @args, groups => \@match if $#+ >0;
	    return Logoved::DB::Rule::Match->new(@args);
	}
    }
    return;
}

1;
