package Logoved::DB::Ruleset;
use Moo;
has 'rules' => (is => 'ro');
has '_subpath2rule' => (is => 'lazy' );

# we need ruleset object (contains rules) -- for rule order, default rule and so on

sub _build__subpath2rule {
    my $self=shift;
    my $rules=$self->rules;
    my $subpath2rule={};
    foreach my $rule (@$rules) {
	$subpath2rule->{$rule->subpath}=$rule;
    }
    return $subpath2rule;
}

sub get_rule_by_subpath {
    my ($self, $subpath)=@_;
    return $self->_subpath2rule->{$subpath};
}

1;
