package Logoved::DB::Stream::Out::Listener;
use Moo;
with 'Logoved::Role::Stream::Out::Listener';
with 'Logoved::DB::Role::Attribute::status';
has 'matchers' => (is => 'ro');
has 'matches' => (is => 'ro', default => sub { [] } );

#sub BUILD {
#    my $self=shift;
#    warn 'created listener for ', $self->rule->name,' on ',$self->stream->section_type,"\n";
#}

sub success {
    $_[0]->status('success');
}

sub error {
    $_[0]->status('error');
}

sub write {
    my ($self,$line)=@_;
    my $chomped_line=$line;
    chomp($chomped_line);
    my $matchers=$self->matchers;
    foreach my $matcher (@$matchers) {
	my $match=$matcher->match($line,$chomped_line);
	if ($match) {
	    push @{$self->matches}, $match;
	}
    }
}

sub commit {
    my $self=shift;
    my $matches=$self->matches;
    my $status=$self->status;
    map {$_->determine_status($status)} @$matches;
    $self->listeners_factory->add_matches($self->matches);
}

1;
